/**
 * Created by IntelliJ IDEA.
 * User: ma
 * Date: 30.01.2003
 * Time: 11:08:27
 * To change this template use Options | File Templates.
 */
package ru.ezhiki.srez.telephone;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;

class ButtonActionListener implements ActionListener
{
    private int idx = 0;
    private Automat automat = null;

    public ButtonActionListener(int idx, Automat automat)
    {
        this.idx = idx;
        this.automat = automat;
    }

    public void actionPerformed(ActionEvent e)
    {
        automat.lastNumberPressed = idx;
        automat.A0(1);
    }
}

public class MainFrame extends JFrame
{
    public Automat automat = new Automat();
    private Displayer displayer = null;

    private JButton buttons[] = new JButton[11];
    private JButton buttonExit = new JButton("  ");
    public JButton buttonRecieverUpDown = new JButton("   ");
    public JTextField editNumbers = new JTextField();

    private JLabel labelBeep = new JLabel("   ");

    public JLabel labelPhoneState1 = new JLabel("  ", JLabel.LEFT);
    public JLabel labelPhoneState2 = new JLabel("  ", JLabel.LEFT);
    public JLabel labelATSState1 = new JLabel("  ", JLabel.LEFT);
    public JLabel labelATSState2 = new JLabel("  ", JLabel.LEFT);

    public MainFrame()
    {
        super(" ");
        initButtons();
        createLayout();
        createActions();

        displayer = new Displayer(this, automat);

        pack();
        setSize(350, 300);

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height)
        {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width)
        {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/2);

        displayer.start();
    }

    private void initButtons()
    {
        buttons[0] = new JButton(" 0 ");
        buttons[1] = new JButton(" 1 ");
        buttons[2] = new JButton(" 2 ");
        buttons[3] = new JButton(" 3 ");
        buttons[4] = new JButton(" 4 ");
        buttons[5] = new JButton(" 5 ");
        buttons[6] = new JButton(" 6 ");
        buttons[7] = new JButton(" 7 ");
        buttons[8] = new JButton(" 8 ");
        buttons[9] = new JButton(" 9 ");
        buttons[10] = new JButton(" C ");

        editNumbers.setEditable(false);
    }

    private void createLayout()
    {
        JPanel panelMain = new JPanel(new BorderLayout());

        JPanel panelButtons = new JPanel(new GridLayout(4, 3));
        for (int i = 0; i < 9; i++)
            panelButtons.add(buttons[i]);

        panelButtons.add(new JPanel());
        panelButtons.add(buttons[9]);
        panelButtons.add(buttons[10]);

        JPanel panelPhone = new JPanel(new BorderLayout());
        panelPhone.add(BorderLayout.NORTH, editNumbers);
        panelPhone.add(BorderLayout.CENTER, panelButtons);
        panelPhone.add(BorderLayout.SOUTH, buttonRecieverUpDown);

        panelPhone.setPreferredSize(new Dimension(200, 250));

        JPanel panelStates = new JPanel(new GridLayout(7, 1));
        Font font = new Font("Monospaced", Font.ITALIC, 14);
        JLabel lab = new JLabel("   ", JLabel.RIGHT);
        lab.setFont(font);
        panelStates.add(lab);
        panelStates.add(labelPhoneState1);
        panelStates.add(labelPhoneState2);
        JLabel lab2 = new JLabel("   ", JLabel.RIGHT);
        lab2.setFont(font);
        panelStates.add(lab2);
        panelStates.add(labelATSState1);
        panelStates.add(labelATSState2);

        panelStates.setPreferredSize(new Dimension(150, 250));

        panelMain.add(BorderLayout.CENTER, panelPhone);
        panelMain.add(BorderLayout.SOUTH, buttonExit);
        panelMain.add(BorderLayout.EAST, panelStates);

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(BorderLayout.CENTER, panelMain);
    }

    private void createActions()
    {
        buttonExit.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                exitWindow();
            }
        });

        for (int i = 0; i < 10; i++)
            buttons[i].addActionListener(new ButtonActionListener(i, automat));

        buttons[10].addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                automat.A0(4);
            }
        });

        buttonRecieverUpDown.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (automat.y0 == 0 || automat.y0 == 1)
                    automat.A0(2);
                else
                    automat.A0(4);
            }
        });
    }

    protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            exitWindow();
        }
    }

    private void exitWindow()
    {
        System.exit(0);
    }
}
